<template>
  <background class="row justify-center">
    <q-card class="col-lg-4 col-md-6 col-sm-10 col-xs-10">
      <q-card-section>
        <div class="text-h3">
          Nastavení
        </div>
      </q-card-section>

      <q-separator inset />

      <q-card-section>
        <q-form
          id="name"
          class="q-gutter-md"
          @submit="onPatch"
        >
          <q-input
            v-model="name"
            filled
            label="Nové jméno *"
            lazy-rules
            :rules="[
              val => val && val.length > 0 || 'Prosím zadejte jméno',
              val => val.length < 255 || 'Jméno je příliš dlouhé'
            ]"
          />
          <q-btn
            label="Změnit jméno"
            :disable="loading"
            type="submit"
            color="primary"
            :loading="loading"
          >
            <template #loading>
              <q-spinner-gears />
            </template>
          </q-btn>
        </q-form>
      </q-card-section>
      <q-separator
        inset
        class="q-my-md"
      />
      <q-card-section>
        <q-form
          id="password"
          class="q-gutter-md"
          @submit="onPatch"
        >
          <q-input
            v-model="password"
            filled
            :type="isPwd ? 'password' : 'text'"
            label="Nové heslo *"
            lazy-rules
            :rules="[
              val => val && val.length > 0 || 'Prosím zadejte heslo',
              val => val.length > 5 || 'Heslo musí mít alespoň 6 znaků',
              val => val.length < 255 || 'Heslo je příliš dlouhé'
            ]"
          >
            <template #append>
              <q-icon
                :name="isPwd ? 'visibility_off' : 'visibility'"
                class="cursor-pointer"
                @click="isPwd = !isPwd"
              />
            </template>
          </q-input>

          <q-btn
            label="Změnit heslo"
            :disable="loading"
            type="submit"
            color="primary"
            :loading="loading"
          >
            <template #loading>
              <q-spinner-gears />
            </template>
          </q-btn>
        </q-form>
      </q-card-section>
      <q-separator
        inset
        class="q-mb-xl"
      />
      <q-card-section>
        <q-form
          class="q-gutter-md"
          @submit="onDelete"
        >
          <q-btn
            label="Smazat účet"
            :disable="loading"
            type="submit"
            color="negative"
            :loading="loading"
          >
            <template #loading>
              <q-spinner-gears />
            </template>
          </q-btn>
        </q-form>
      </q-card-section>
    </q-card>
  </background>
</template>

<script lang="ts">
import { useQuasar } from 'quasar'
import { ref } from 'vue'
import { useRouter } from 'vue-router'
import { UserPatch } from 'web_trains_types'

import background from '@/components/Background.vue'
import useUserStore from '@/store/userStore'

export default {
  name: 'User',
  components: {
    background
  },

  setup (): any {
    const $q = useQuasar()
    const user = useUserStore()
    const router = useRouter()

    const name = ref('')
    const password = ref('')
    const isPwd = ref(true)
    const loading = ref(false)

    name.value = user.data.name

    return {
      name,
      password,
      isPwd,
      loading,

      onPatch (form: any) {
        loading.value = true
        const type = form.target.id
        let patch: UserPatch|null = null

        if (type === 'password') {
          patch = {
            password: password.value
          }
        }

        if (type === 'name') {
          patch = {
            name: name.value
          }
        }

        if (patch === null) {
          return
        }

        user.patch(patch)
          .then(
            () => {
              $q.notify({
                type: 'positive',
                message: 'Změna provedena'
              })
            })
          .finally(
            () => {
              loading.value = false
            }
          )
      },
      onDelete () {
        user.delete()
          .then(() => {
            user.signOut()

            $q.notify({
              type: 'positive',
              message: 'Uživatel smazán'
            })

            router.push({ name: 'home' })
          })
      }

    }
  }
}

</script>
